# Autobuild
**Autobuild** is a framework for building packages and for managing the
dependencies of a package on other packages. It provides a common
interface to configuring and building any package, but it is not a
build system like make or cmake. You will still need platform-specific
make, cmake, or project files to configure and build your
library. Autobuild will, however, allow you invoke these commands and
package the product with a common interface.

*Important: This Autobuild is not the same as or derived from GNU Autobuild, but they are similar enough to cause confusion.*

## Install

`pip install --upgrade autobuild -i https://git.alchemyviewer.org/api/v4/projects/54/packages/pypi/simple`

## Environment variables

| Name | Default | Description |
|-|-|-|
| AUTOBUILD_ADDRSIZE | 32 | Target address size |
| AUTOBUILD_BUILD_ID | - | Build identifier |
| AUTOBUILD_CONFIGURATION | - | Target build configuration |
| AUTOBUILD_CONFIG_FILE | autobuild.xml | Autobuild configuration filename |
| AUTOBUILD_INSTALLABLE_CACHE | - | Location of local download cache |
| AUTOBUILD_LOGLEVEL | WARNING | Log level |
| AUTOBUILD_PLATFORM | - | Target platform |
| AUTOBUILD_SCM_SEARCH | true | Whether to search for .git in parent directories if using SCM version discovery |
| AUTOBUILD_VARIABLES_FILE | - | .env file to load |
| AUTOBUILD_VSVER | - | Target Visual Studio version to use on windows |
